// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: internal/module/gitops/rpc/rpc.proto

package rpc

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
)

// Validate checks the field values on ObjectsToSynchronizeRequest with the
// rules defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *ObjectsToSynchronizeRequest) Validate() error {
	if m == nil {
		return nil
	}

	if utf8.RuneCountInString(m.GetProjectId()) < 1 {
		return ObjectsToSynchronizeRequestValidationError{
			field:  "ProjectId",
			reason: "value length must be at least 1 runes",
		}
	}

	// no validation rules for CommitId

	if len(m.GetPaths()) < 1 {
		return ObjectsToSynchronizeRequestValidationError{
			field:  "Paths",
			reason: "value must contain at least 1 item(s)",
		}
	}

	for idx, item := range m.GetPaths() {
		_, _ = idx, item

		if v, ok := interface{}(item).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return ObjectsToSynchronizeRequestValidationError{
					field:  fmt.Sprintf("Paths[%v]", idx),
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	}

	return nil
}

// ObjectsToSynchronizeRequestValidationError is the validation error returned
// by ObjectsToSynchronizeRequest.Validate if the designated constraints
// aren't met.
type ObjectsToSynchronizeRequestValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ObjectsToSynchronizeRequestValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ObjectsToSynchronizeRequestValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ObjectsToSynchronizeRequestValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ObjectsToSynchronizeRequestValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ObjectsToSynchronizeRequestValidationError) ErrorName() string {
	return "ObjectsToSynchronizeRequestValidationError"
}

// Error satisfies the builtin error interface
func (e ObjectsToSynchronizeRequestValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sObjectsToSynchronizeRequest.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ObjectsToSynchronizeRequestValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ObjectsToSynchronizeRequestValidationError{}

// Validate checks the field values on ObjectsToSynchronizeResponse with the
// rules defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *ObjectsToSynchronizeResponse) Validate() error {
	if m == nil {
		return nil
	}

	switch m.Message.(type) {

	case *ObjectsToSynchronizeResponse_Header_:

		if v, ok := interface{}(m.GetHeader()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return ObjectsToSynchronizeResponseValidationError{
					field:  "Header",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	case *ObjectsToSynchronizeResponse_Object_:

		if v, ok := interface{}(m.GetObject()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return ObjectsToSynchronizeResponseValidationError{
					field:  "Object",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	case *ObjectsToSynchronizeResponse_Trailer_:

		if v, ok := interface{}(m.GetTrailer()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return ObjectsToSynchronizeResponseValidationError{
					field:  "Trailer",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	default:
		return ObjectsToSynchronizeResponseValidationError{
			field:  "Message",
			reason: "value is required",
		}

	}

	return nil
}

// ObjectsToSynchronizeResponseValidationError is the validation error returned
// by ObjectsToSynchronizeResponse.Validate if the designated constraints
// aren't met.
type ObjectsToSynchronizeResponseValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ObjectsToSynchronizeResponseValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ObjectsToSynchronizeResponseValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ObjectsToSynchronizeResponseValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ObjectsToSynchronizeResponseValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ObjectsToSynchronizeResponseValidationError) ErrorName() string {
	return "ObjectsToSynchronizeResponseValidationError"
}

// Error satisfies the builtin error interface
func (e ObjectsToSynchronizeResponseValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sObjectsToSynchronizeResponse.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ObjectsToSynchronizeResponseValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ObjectsToSynchronizeResponseValidationError{}

// Validate checks the field values on ObjectsToSynchronizeResponse_Header with
// the rules defined in the proto definition for this message. If any rules
// are violated, an error is returned.
func (m *ObjectsToSynchronizeResponse_Header) Validate() error {
	if m == nil {
		return nil
	}

	if utf8.RuneCountInString(m.GetCommitId()) < 1 {
		return ObjectsToSynchronizeResponse_HeaderValidationError{
			field:  "CommitId",
			reason: "value length must be at least 1 runes",
		}
	}

	// no validation rules for ProjectId

	return nil
}

// ObjectsToSynchronizeResponse_HeaderValidationError is the validation error
// returned by ObjectsToSynchronizeResponse_Header.Validate if the designated
// constraints aren't met.
type ObjectsToSynchronizeResponse_HeaderValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ObjectsToSynchronizeResponse_HeaderValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ObjectsToSynchronizeResponse_HeaderValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ObjectsToSynchronizeResponse_HeaderValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ObjectsToSynchronizeResponse_HeaderValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ObjectsToSynchronizeResponse_HeaderValidationError) ErrorName() string {
	return "ObjectsToSynchronizeResponse_HeaderValidationError"
}

// Error satisfies the builtin error interface
func (e ObjectsToSynchronizeResponse_HeaderValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sObjectsToSynchronizeResponse_Header.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ObjectsToSynchronizeResponse_HeaderValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ObjectsToSynchronizeResponse_HeaderValidationError{}

// Validate checks the field values on ObjectsToSynchronizeResponse_Object with
// the rules defined in the proto definition for this message. If any rules
// are violated, an error is returned.
func (m *ObjectsToSynchronizeResponse_Object) Validate() error {
	if m == nil {
		return nil
	}

	if utf8.RuneCountInString(m.GetSource()) < 1 {
		return ObjectsToSynchronizeResponse_ObjectValidationError{
			field:  "Source",
			reason: "value length must be at least 1 runes",
		}
	}

	// no validation rules for Data

	return nil
}

// ObjectsToSynchronizeResponse_ObjectValidationError is the validation error
// returned by ObjectsToSynchronizeResponse_Object.Validate if the designated
// constraints aren't met.
type ObjectsToSynchronizeResponse_ObjectValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ObjectsToSynchronizeResponse_ObjectValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ObjectsToSynchronizeResponse_ObjectValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ObjectsToSynchronizeResponse_ObjectValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ObjectsToSynchronizeResponse_ObjectValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ObjectsToSynchronizeResponse_ObjectValidationError) ErrorName() string {
	return "ObjectsToSynchronizeResponse_ObjectValidationError"
}

// Error satisfies the builtin error interface
func (e ObjectsToSynchronizeResponse_ObjectValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sObjectsToSynchronizeResponse_Object.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ObjectsToSynchronizeResponse_ObjectValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ObjectsToSynchronizeResponse_ObjectValidationError{}

// Validate checks the field values on ObjectsToSynchronizeResponse_Trailer
// with the rules defined in the proto definition for this message. If any
// rules are violated, an error is returned.
func (m *ObjectsToSynchronizeResponse_Trailer) Validate() error {
	if m == nil {
		return nil
	}

	return nil
}

// ObjectsToSynchronizeResponse_TrailerValidationError is the validation error
// returned by ObjectsToSynchronizeResponse_Trailer.Validate if the designated
// constraints aren't met.
type ObjectsToSynchronizeResponse_TrailerValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ObjectsToSynchronizeResponse_TrailerValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ObjectsToSynchronizeResponse_TrailerValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ObjectsToSynchronizeResponse_TrailerValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ObjectsToSynchronizeResponse_TrailerValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ObjectsToSynchronizeResponse_TrailerValidationError) ErrorName() string {
	return "ObjectsToSynchronizeResponse_TrailerValidationError"
}

// Error satisfies the builtin error interface
func (e ObjectsToSynchronizeResponse_TrailerValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sObjectsToSynchronizeResponse_Trailer.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ObjectsToSynchronizeResponse_TrailerValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ObjectsToSynchronizeResponse_TrailerValidationError{}
